]> gitweb.factorcode.org Git - factor.git/blob - build.sh
build.sh: allow arch -x86_64 builds on Apple Silicon.
[factor.git] / build.sh
1 #!/usr/bin/env bash
2
3 # Programs returning != 0 will not cause script to exit
4 set +e
5
6 # Case insensitive string comparison
7 shopt -s nocaseglob
8 #shopt -s nocasematch
9
10 ECHO=echo
11 OS=
12 ARCH=
13 WORD=
14 GIT_PROTOCOL=${GIT_PROTOCOL:="git"}
15 GIT_URL=${GIT_URL:=$GIT_PROTOCOL"://github.com/factor/factor.git"}
16 SCRIPT_ARGS="$*"
17
18 REQUIRE_CLANG_VERSION=3.1
19
20 # return 1 on found
21 test_program_installed() {
22     if ! [[ -n $(type -p $1) ]] ; then
23         return 0;
24     fi
25     return 1;
26 }
27
28 # return 1 on found
29 test_programs_installed() {
30     local installed=0;
31     $ECHO -n "Checking for all($*)..."
32     for i in "$@" ;
33     do
34         test_program_installed $i
35         if [[ $? -eq 1 ]]; then
36             installed=$(( $installed + 1 ))
37         fi
38     done
39     if [[ $installed -eq $# ]] ; then
40         $ECHO "found!"
41         return 1
42     else
43         $ECHO "all not found."
44         return 0
45     fi
46 }
47
48 exit_script() {
49     if [[ $FIND_MAKE_TARGET = true ]] ; then
50         # Must be echo not $ECHO
51         echo $MAKE_TARGET;
52     fi
53     exit $1
54 }
55
56 ensure_program_installed() {
57     local installed=0;
58     $ECHO -n "Checking for any($*)..."
59     for i in "$@" ;
60     do
61         test_program_installed $i
62         if [[ $? -eq 1 ]]; then
63             $ECHO "found $i!"
64             installed=$(( $installed + 1 ))
65             return
66         fi
67     done
68     $ECHO "none found."
69     $ECHO -n "Install "
70     if [[ $# -eq 1 ]] ; then
71         $ECHO -n $1
72     else
73         $ECHO -n "any of [ $* ]"
74     fi
75     $ECHO " and try again."
76     if [[ $OS == macosx ]] ; then
77         $ECHO "If you have Xcode 4.3 or higher installed, you must install the"
78         $ECHO "Command Line Tools from Xcode Preferences > Downloads in order"
79         $ECHO "to build Factor."
80     fi
81     exit_script 1;
82 }
83
84 check_ret() {
85     RET=$?
86     if [[ $RET -ne 0 ]] ; then
87        $ECHO $1 failed
88        exit_script 2
89     fi
90 }
91
92 set_downloader() {
93     test_program_installed wget
94     if [[ $? -ne 0 ]] ; then
95         DOWNLOADER="wget -nd"
96         DOWNLOADER_NAME=wget
97         return
98     fi
99     test_program_installed curl
100     if [[ $? -ne 0 ]] ; then
101         DOWNLOADER="curl -L -f -O"
102         DOWNLOADER_NAME=curl
103         return
104     fi
105     $ECHO "error: wget or curl required"
106     exit_script 11
107 }
108
109 set_md5sum() {
110     test_program_installed md5sum
111     if [[ $? -ne 0 ]] ; then
112         MD5SUM=md5sum
113     else
114         MD5SUM="md5 -r"
115     fi
116 }
117
118 semver_into() {
119     RE_SEMVER="^([0-9]*)\.([0-9]*)\.([0-9]*)-?(.*)?$" # 3.3.3-5
120     CLANG_RE_OLD="^([0-9]*)\.([0-9]*)-?(.*)?$" # 3.3-5
121     if [[ $1 =~ $RE_SEMVER ]] ; then
122         export "$2=${BASH_REMATCH[1]}"
123         export "$3=${BASH_REMATCH[2]}"
124         export "$4=${BASH_REMATCH[3]}"
125         export "$5=${BASH_REMATCH[4]}"
126     elif [[ $1 =~ $CLANG_RE_OLD ]] ; then
127         export "$2=${BASH_REMATCH[1]}"
128         export "$3=${BASH_REMATCH[2]}"
129         export "$4=0"
130         export "$5=${BASH_REMATCH[3]}"
131     else
132         echo "unsupported version number, please report a bug: $1"
133         exit 123
134     fi
135 }
136
137 clang_version_ok() {
138     CLANG_VERSION=$(clang --version | head -n1)
139     CLANG_VERSION_RE='^[a-zA-Z0-9 ]* version (.*)$' # 3.3-5
140     if [[ $CLANG_VERSION =~ $CLANG_VERSION_RE ]] ; then
141         export "CLANG_VERSION=${BASH_REMATCH[1]}"
142         local CLANG_MAJOR CLANG_MINOR CLANG_PATCH CLANG_SPECIAL
143         semver_into "$CLANG_VERSION" CLANG_MAJOR CLANG_MINOR CLANG_PATCH CLANG_SPECIAL
144         if [[ $CLANG_MAJOR -lt 3
145             || ( $CLANG_MAJOR -eq 3 && $CLANG_MINOR -le 1 )
146             ]] ; then
147             echo "clang version required >= $REQUIRE_CLANG_VERSION, got $CLANG_VERSION"
148             return 1
149         fi
150     else
151         return 1
152     fi
153     return 0
154 }
155
156 set_cc() {
157     # on Cygwin we MUST use the MinGW "cross-compiler", therefore check these first
158     # furthermore, we prefer 64 bit over 32 bit versions if both are available
159
160     # we need this condition so we don't find a mingw32 compiler on linux
161     if [[ $OS == windows ]] ; then
162         test_programs_installed x86_64-w64-mingw32-gcc x86_64-w64-mingw32-g++
163         if [[ $? -ne 0 ]] ; then
164             [ -z "$CC" ] && CC=x86_64-w64-mingw32-gcc
165             [ -z "$CXX" ] && CXX=x86_64-w64-mingw32-g++
166             return
167         fi
168
169         test_programs_installed i686-w64-mingw32-gcc i686-w64-mingw32-g++
170         if [[ $? -ne 0 ]] ; then
171             [ -z "$CC" ] && CC=i686-w64-mingw32-gcc
172             [ -z "$CXX" ] && CXX=i686-w64-mingw32-g++
173             return
174         fi
175     fi
176
177     test_programs_installed clang clang++
178     if [[ $? -ne 0 ]] && clang_version_ok ; then
179         [ -z "$CC" ] && CC=clang
180         [ -z "$CXX" ] && CXX=clang++
181         return
182     fi
183
184     # gcc and g++ will fail to correctly build Factor on Cygwin
185     test_programs_installed gcc g++
186     if [[ $? -ne 0 ]] ; then
187         [ -z "$CC" ] && CC=gcc
188         [ -z "$CXX" ] && CXX=g++
189         return
190     fi
191
192     $ECHO "error: high enough version of either (clang/clang++) or (gcc/g++) required!"
193     exit_script 10
194 }
195
196 set_make() {
197     case $OS in
198         freebsd) MAKE=gmake ;;
199         *) MAKE=make ;;
200     esac
201     if [[ $MAKE = 'gmake' ]] ; then
202         ensure_program_installed gmake
203     fi
204 }
205
206 check_installed_programs() {
207     ensure_program_installed chmod
208     ensure_program_installed uname
209     ensure_program_installed git
210     ensure_program_installed wget curl
211     ensure_program_installed clang x86_64-w64-mingw32-gcc i686-w64-mingw32-gcc gcc
212     ensure_program_installed clang++ x86_64-w64-mingw32-g++ i686-w64-mingw32-g++ g++ cl
213     ensure_program_installed make gmake
214     ensure_program_installed md5sum md5
215     ensure_program_installed cut
216 }
217
218 check_library_exists() {
219     GCC_TEST=factor-library-test.c
220     GCC_OUT=factor-library-test.out
221     $ECHO -n "Checking for library $1..."
222     $ECHO "int main(){return 0;}" > $GCC_TEST
223     $CC $GCC_TEST -o $GCC_OUT -l $1 2>&-
224     if [[ $? -ne 0 ]] ; then
225         $ECHO "not found."
226     else
227         $ECHO "found."
228     fi
229     $DELETE -f $GCC_TEST
230     check_ret $DELETE
231     $DELETE -f $GCC_OUT
232     check_ret $DELETE
233 }
234
235 check_X11_libraries() {
236     check_library_exists GL
237     check_library_exists X11
238     check_library_exists pango-1.0
239 }
240
241 check_gtk_libraries() {
242     check_library_exists gobject-2.0
243     check_library_exists gtk-x11-2.0
244     check_library_exists gdk-x11-2.0
245     check_library_exists gdk_pixbuf-2.0
246     check_library_exists gtkglext-x11-1.0
247     check_library_exists atk-1.0
248     check_library_exists gio-2.0
249     check_library_exists gdkglext-x11-1.0
250     check_library_exists pango-1.0
251 }
252
253
254 check_libraries() {
255     case $OS in
256         linux) check_X11_libraries
257                check_gtk_libraries;;
258         unix) check_gtk_libraries;;
259     esac
260 }
261
262 check_factor_exists() {
263     if [[ -d "factor" ]] ; then
264         $ECHO "A directory called 'factor' already exists."
265         $ECHO "Rename or delete it and try again."
266         exit_script 4
267     fi
268 }
269
270 find_os() {
271     if [[ -n $OS ]] ; then return; fi
272     $ECHO "Finding OS..."
273     local uname_s=$(uname -s)
274     check_ret uname
275     case $uname_s in
276         CYGWIN_NT-5.2-WOW64) OS=windows;;
277         *CYGWIN_NT*) OS=windows;;
278         *CYGWIN*) OS=windows;;
279         MINGW32*) OS=windows;;
280         MINGW64*) OS=windows;;
281         MSYS_NT*) OS=windows;;
282         *darwin*) OS=macosx;;
283         *Darwin*) OS=macosx;;
284         *linux*) OS=linux;;
285         *Linux*) OS=linux;;
286         FreeBSD) OS=freebsd;;
287         Haiku) OS=haiku;;
288     esac
289 }
290
291 find_architecture() {
292     if [[ -n $ARCH ]] ; then return; fi
293     $ECHO "Finding ARCH..."
294     uname_m=$(uname -m)
295     check_ret uname
296     case $uname_m in
297        i386) ARCH=x86;;
298        i686) ARCH=x86;;
299        i86pc) ARCH=x86;;
300        amd64) ARCH=x86;;
301        ppc64) ARCH=ppc;;
302        *86) ARCH=x86;;
303        *86_64) ARCH=x86;;
304        arm64) ARCH=arm64;;
305        aarch64) ARCH=arm64;;
306        arm64) ARCH=arm64;;
307        iPhone5*[3-9]) ARCH=arm64;;
308        iPhone[6-9]*) ARCH=arm64;;
309        iPhone[1-9][0-9]*) ARCH=arm64;;
310        iPad[4-9]*) ARCH=arm64;;
311        iPad[1-9][0-9]*) ARCH=arm64;;
312        AppleTV[5-9]*) ARCH=arm64;;
313        AppleTV[1-9][0-9]*) ARCH=arm64;;
314        "Power Macintosh") ARCH=ppc;;
315     esac
316 }
317
318 find_num_cores() {
319     $ECHO "Finding NUM_CORES..."
320     NUM_CORES=1
321     uname_s=$(uname -s)
322     check_ret uname
323     case $uname_s in
324         CYGWIN_NT-5.2-WOW64 | *CYGWIN_NT* | *CYGWIN* | MINGW32*) NUM_CORES=$NUMBER_OF_PROCESSORS;;
325         *linux* | *Linux*) NUM_CORES=$(getconf _NPROCESSORS_ONLN || nproc);;
326         *darwin* | *Darwin* | freebsd) NUM_CORES=$(sysctl -n hw.ncpu);;
327     esac
328 }
329
330 find_word_size() {
331     if [[ -n $WORD ]] ; then return; fi
332     $ECHO "Finding WORD..."
333     WORD=$(find_word_size_cpp || find_word_size_c)
334 }
335
336 find_word_size_cpp() {
337     SIXTY_FOUR='defined(__aarch64__) || defined(__x86_64__) || defined(_M_AMD64) || defined(__PPC64__) || defined(__64BIT__)'
338     THIRTY_TWO='defined(i386) || defined(__i386) || defined(__i386__) || defined(_MIX86)'
339     $CC -E -xc <(echo -e "#if ${SIXTY_FOUR}\n64\n#elif ${THIRTY_TWO}\n32\n#endif") | tail -1
340 }
341
342 find_word_size_c() {
343     C_WORD="factor-word-size"
344     TEST_PROGRAM="int main(){ return (long)(8*sizeof(void*)); }"
345     echo $TEST_PROGRAM | $CC -o $C_WORD -xc -
346     check_ret $CC
347     ./$C_WORD
348     WORD_OUT=$?
349     case $WORD_OUT in
350         32) ;;
351         64) ;;
352         *)
353             echo "Word size should be 32/64, got '$WORD_OUT'"
354             exit_script 15;;
355     esac
356     $DELETE -f $C_WORD
357     echo "$WORD_OUT"
358 }
359
360 set_factor_binary() {
361     case $OS in
362         windows) FACTOR_BINARY=factor.com;;
363         *) FACTOR_BINARY=factor;;
364     esac
365 }
366
367 set_factor_library() {
368     case $OS in
369         windows) FACTOR_LIBRARY=factor.dll;;
370         macosx) FACTOR_LIBRARY=libfactor.dylib;;
371         *) FACTOR_LIBRARY=libfactor.a;;
372     esac
373 }
374
375 set_factor_image() {
376     FACTOR_IMAGE=factor.image
377     FACTOR_IMAGE_FRESH=factor.image.fresh
378 }
379
380 echo_build_info() {
381     $ECHO OS=$OS
382     $ECHO ARCH=$ARCH
383     $ECHO NUM_CORES=$NUM_CORES
384     $ECHO WORD=$WORD
385     $ECHO DEBUG=$DEBUG
386     $ECHO REPRODUCIBLE=$REPRODUCIBLE
387     $ECHO CURRENT_BRANCH=$CURRENT_BRANCH
388     $ECHO FACTOR_BINARY=$FACTOR_BINARY
389     $ECHO FACTOR_LIBRARY=$FACTOR_LIBRARY
390     $ECHO FACTOR_IMAGE=$FACTOR_IMAGE
391     $ECHO MAKE_TARGET=$MAKE_TARGET
392     $ECHO BOOT_IMAGE=$BOOT_IMAGE
393     $ECHO MAKE_IMAGE_TARGET=$MAKE_IMAGE_TARGET
394     $ECHO GIT_PROTOCOL=$GIT_PROTOCOL
395     $ECHO GIT_URL=$GIT_URL
396     $ECHO DOWNLOADER=$DOWNLOADER
397     $ECHO CC=$CC
398     $ECHO CXX=$CXX
399     $ECHO MAKE=$MAKE
400     $ECHO COPY=$COPY
401     $ECHO DELETE=$DELETE
402 }
403
404 check_os_arch_word() {
405     if ! [[ -n $OS && -n $ARCH && -n $WORD ]] ; then
406         $ECHO "OS: $OS"
407         $ECHO "ARCH: $ARCH"
408         $ECHO "WORD: $WORD"
409         $ECHO "OS, ARCH, or WORD is empty.  Please report this."
410
411         $ECHO $MAKE_TARGET
412         exit_script 5
413     fi
414 }
415
416 set_build_info() {
417     check_os_arch_word
418     if [[ $OS == linux && $ARCH == ppc ]] ; then
419         MAKE_IMAGE_TARGET=linux-ppc.32
420         MAKE_TARGET=linux-ppc-32
421     elif [[ $OS == linux && $ARCH == arm64 ]] ; then
422         MAKE_IMAGE_TARGET=unix-arm.64
423         MAKE_TARGET=linux-arm-64
424     elif [[ $OS == macosx && $ARCH == arm64 ]] ; then
425         MAKE_IMAGE_TARGET=unix-arm.64
426         MAKE_TARGET=macosx-arm64
427     elif [[ $OS == windows && $ARCH == x86 && $WORD == 64 ]] ; then
428         MAKE_IMAGE_TARGET=windows-x86.64
429         MAKE_TARGET=windows-x86-64
430     elif [[ $OS == windows && $ARCH == x86 && $WORD == 32 ]] ; then
431         MAKE_IMAGE_TARGET=windows-x86.32
432         MAKE_TARGET=windows-x86-32
433     elif [[ $ARCH == x86 && $WORD == 64 ]] ; then
434         MAKE_IMAGE_TARGET=unix-x86.64
435         MAKE_TARGET=$OS-x86-64
436     elif [[ $ARCH == x86 && $WORD == 32 ]] ; then
437         MAKE_IMAGE_TARGET=unix-x86.32
438         MAKE_TARGET=$OS-x86-32
439     else
440         MAKE_IMAGE_TARGET=$ARCH.$WORD
441         MAKE_TARGET=$OS-$ARCH-$WORD
442     fi
443     BOOT_IMAGE=boot.$MAKE_IMAGE_TARGET.image
444 }
445
446 parse_build_info() {
447     ensure_program_installed cut
448     $ECHO "Parsing make target from command line: $1"
449     OS=$(echo $1 | cut -d '-' -f 1)
450     ARCH=$(echo $1 | cut -d '-' -f 2)
451     WORD=$(echo $1 | cut -d '-' -f 3)
452
453     if [[ $OS == linux && $ARCH == ppc ]] ; then WORD=32; fi
454     if [[ $OS == linux && $ARCH == arm ]] ; then WORD=32; fi
455     if [[ $OS == macosx && $ARCH == ppc ]] ; then WORD=32; fi
456
457     $ECHO "OS=$OS"
458     $ECHO "ARCH=$ARCH"
459     $ECHO "WORD=$WORD"
460 }
461
462 find_build_info() {
463     find_os
464     find_architecture
465     find_num_cores
466     set_cc
467     find_word_size
468     set_current_branch
469     set_factor_binary
470     set_factor_library
471     set_factor_image
472     set_build_info
473     set_downloader
474     set_make
475     echo_build_info
476 }
477
478 invoke_git() {
479     git "$@"
480     check_ret git
481 }
482
483 git_clone() {
484     $ECHO "Downloading the git repository from github.com..."
485     invoke_git clone $GIT_URL
486 }
487
488 update_script_name() {
489     $ECHO "$(dirname $0)/_update.sh"
490 }
491
492 update_script() {
493     local -r update_script=$(update_script_name)
494     local -r bash_path=$(which bash)
495     $ECHO "updating from ${CURRENT_BRANCH}"
496     $ECHO "#!$bash_path" >"$update_script"
497     $ECHO "git pull \"$GIT_URL\" ${CURRENT_BRANCH}" >>"$update_script"
498     $ECHO "if [[ \$? -eq 0 ]]; then exec \"$0\" $SCRIPT_ARGS; else echo \"git pull failed\"; exit 2; fi" \
499         >>"$update_script"
500     $ECHO "exit 0" >>"$update_script"
501
502     chmod 755 "$update_script"
503     exec "$update_script"
504 }
505
506 update_script_changed() {
507     invoke_git diff --stat "$(invoke_git merge-base HEAD FETCH_HEAD)" FETCH_HEAD | grep 'build\.sh' >/dev/null
508 }
509
510 git_fetch() {
511     $ECHO "Fetching the git repository from github.com..."
512     set_current_branch
513
514     rm -f "$(update_script_name)"
515     $ECHO git fetch "$GIT_URL" "${CURRENT_BRANCH}"
516     invoke_git fetch "$GIT_URL" "${CURRENT_BRANCH}"
517
518     if update_script_changed; then
519         $ECHO "Updating and restarting the build.sh script..."
520         update_script
521     else
522         $ECHO "Updating the working tree..."
523         invoke_git pull "$GIT_URL" "${CURRENT_BRANCH}"
524     fi
525 }
526
527 cd_factor() {
528     cd "factor"
529     check_ret cd
530 }
531
532 set_copy() {
533     case $OS in
534         windows) COPY=cp;;
535         *) COPY=cp;;
536     esac
537 }
538
539 set_delete() {
540     case $OS in
541         windows) DELETE=rm;;
542         *) DELETE=rm;;
543     esac
544 }
545
546 backup_factor() {
547     $ECHO "Backing up factor..."
548     $COPY $FACTOR_BINARY $FACTOR_BINARY.bak
549     $COPY $FACTOR_LIBRARY $FACTOR_LIBRARY.bak
550     $COPY $BOOT_IMAGE $BOOT_IMAGE.bak
551     $COPY $FACTOR_IMAGE $FACTOR_IMAGE.bak
552     $ECHO "Done with backup."
553 }
554
555 check_makefile_exists() {
556     if [[ ! -e "GNUmakefile" ]] ; then
557         $ECHO ""
558         $ECHO "***GNUmakefile not found***"
559         $ECHO "You are likely in the wrong directory."
560         $ECHO "Run this script from your factor directory:"
561         $ECHO "     ./build.sh"
562         exit_script 6
563     fi
564 }
565
566 invoke_make() {
567     check_makefile_exists
568     $MAKE $MAKE_OPTS "$@"
569     check_ret $MAKE
570 }
571
572 make_clean() {
573     invoke_make clean
574 }
575
576 make_factor() {
577     $ECHO "Building factor with $NUM_CORES cores"
578     invoke_make CC=$CC CXX=$CXX $MAKE_TARGET -j$NUM_CORES
579 }
580
581 make_clean_factor() {
582     make_clean
583     make_factor
584 }
585
586 current_git_branch() {
587     # git rev-parse --abbrev-ref HEAD # outputs HEAD for detached head
588     # outputs nothing for detached HEAD, which is fine for ``git fetch``
589     git describe --all --exact-match 2>/dev/null | sed 's=.*/=='
590 }
591
592 check_url() {
593     if [[ $DOWNLOADER_NAME == 'wget' ]]; then
594         if [[ $(wget -S --spider $1 2>&1 | grep 'HTTP/1.1 200 OK') ]]; then
595             return 0
596         else
597             return 1
598         fi
599     elif [[ $DOWNLOADER_NAME == 'curl' ]]; then
600         local code=$(curl -sL -w "%{http_code}\\n" "$1" -o /dev/null)
601         if [[ $code -eq 200 ]]; then return 0; else return 1; fi
602     else
603         $ECHO "error: wget or curl required in check_url"
604         exit_script 12
605     fi
606 }
607
608 # If we are on a branch, first try to get a boot image for that branch.
609 # Otherwise, just use `master`
610 set_boot_image_vars() {
611     set_current_branch
612     local url="http://downloads.factorcode.org/images/${CURRENT_BRANCH}/checksums.txt"
613     check_url $url
614     if [[ $? -eq 0 ]]; then
615         CHECKSUM_URL="$url"
616         BOOT_IMAGE_URL="http://downloads.factorcode.org/images/${CURRENT_BRANCH}/${BOOT_IMAGE}"
617     else
618         $ECHO "boot image for branch \`${CURRENT_BRANCH}\` is not on server, trying master instead"
619         $ECHO "  tried nonexistent url: ${url}"
620         CHECKSUM_URL="http://downloads.factorcode.org/images/master/checksums.txt"
621         BOOT_IMAGE_URL="http://downloads.factorcode.org/images/master/${BOOT_IMAGE}"
622     fi
623 }
624
625 set_current_branch() {
626     if [ -n "${CI_BRANCH}" ]; then
627         CURRENT_BRANCH="${CI_BRANCH}"
628     else
629         CURRENT_BRANCH=$(current_git_branch)
630     fi
631 }
632
633 update_boot_image() {
634     set_boot_image_vars
635     $ECHO "Deleting old images..."
636     $DELETE checksums.txt* > /dev/null 2>&1
637     # delete boot images with one or two characters after the dot
638     $DELETE $BOOT_IMAGE.{?,??} > /dev/null 2>&1
639     $DELETE temp/staging.*.image > /dev/null 2>&1
640     if [[ -f $BOOT_IMAGE ]] ; then
641         get_url $CHECKSUM_URL
642         local factorcode_md5=$(cat checksums.txt | grep $BOOT_IMAGE | cut -f2 -d' ')
643         set_md5sum
644         local disk_md5=$($MD5SUM $BOOT_IMAGE | cut -f1 -d' ')
645         $ECHO "Factorcode md5: $factorcode_md5";
646         $ECHO "Disk md5: $disk_md5";
647         if [[ "$factorcode_md5" == "$disk_md5" ]] ; then
648             $ECHO "Your disk boot image matches the one on downloads.factorcode.org."
649         else
650             $DELETE $BOOT_IMAGE > /dev/null 2>&1
651             get_boot_image
652         fi
653     else
654         get_boot_image
655     fi
656 }
657
658 get_boot_image() {
659     $ECHO "Downloading boot image $BOOT_IMAGE."
660     get_url "${BOOT_IMAGE_URL}"
661 }
662
663 get_url() {
664     if [[ -z $DOWNLOADER ]] ; then
665         set_downloader;
666     fi
667     $ECHO $DOWNLOADER $1 ;
668     $DOWNLOADER $1
669     check_ret $DOWNLOADER
670 }
671
672 get_config_info() {
673     find_build_info
674     check_installed_programs
675     check_libraries
676 }
677
678 copy_fresh_image() {
679     $ECHO "Copying $FACTOR_IMAGE to $FACTOR_IMAGE_FRESH..."
680     $COPY $FACTOR_IMAGE $FACTOR_IMAGE_FRESH
681 }
682
683 bootstrap() {
684     ./$FACTOR_BINARY -i=$BOOT_IMAGE
685     copy_fresh_image
686 }
687
688 install() {
689     check_factor_exists
690     get_config_info
691     git_clone
692     cd_factor
693     make_factor
694     set_boot_image_vars
695     get_boot_image
696     bootstrap
697 }
698
699 update() {
700     get_config_info
701     git_fetch
702     backup_factor
703     make_clean_factor
704 }
705
706 download_and_bootstrap() {
707     update_boot_image
708     bootstrap
709 }
710
711 net_bootstrap_no_pull() {
712     get_config_info
713     make_clean_factor
714     download_and_bootstrap
715 }
716
717 refresh_image() {
718     ./$FACTOR_BINARY -e="USING: vocabs.loader vocabs.refresh system memory ; refresh-all save 0 exit"
719     check_ret factor
720 }
721
722 make_boot_image() {
723     ./$FACTOR_BINARY -run="bootstrap.image" "$MAKE_IMAGE_TARGET"
724     check_ret factor
725 }
726
727 install_deps_apt() {
728     sudo apt install --yes libc6-dev libpango1.0-dev libx11-dev xorg-dev libgtk2.0-dev gtk2-engines-pixbuf libgtkglext1-dev wget git git-doc rlwrap clang make screen tmux libssl-dev
729     check_ret sudo
730 }
731
732 install_deps_pacman() {
733     sudo pacman --noconfirm -Syu gcc clang make rlwrap git wget pango glibc gtk2 gtk3 gtkglext gtk-engines gdk-pixbuf2 libx11 screen tmux
734     check_ret sudo
735 }
736
737 install_deps_dnf() {
738     sudo dnf --assumeyes install gcc gcc-c++ glibc-devel binutils libX11-devel pango-devel gtk3-devel gdk-pixbuf2-devel gtkglext-devel tmux rlwrap wget
739     check_ret sudo
740 }
741
742 install_deps_pkg() {
743     sudo pkg install --yes git gmake gcc rlwrap ripgrep curl gmake x11-toolkits/gtk30 x11-toolkits/gtkglext pango cairo vim
744 }
745
746
747 install_deps_macosx() {
748     test_program_installed git
749     if [[ $? -ne 1 ]] ; then
750         ensure_program_installed yes
751         $ECHO "git not found."
752         $ECHO "This script requires either git-core or port."
753         $ECHO "If it fails, install git-core or port and try again."
754         ensure_program_installed port
755         $ECHO "Installing git-core with port...this will take awhile."
756         yes | sudo port install git-core
757     fi
758 }
759
760 usage() {
761     $ECHO "usage: $0 command [optional-target]"
762     $ECHO "  install - git clone, compile, bootstrap"
763     $ECHO "  deps-apt - install required packages for Factor on Linux using apt"
764     $ECHO "  deps-pacman - install required packages for Factor on Linux using pacman"
765     $ECHO "  deps-dnf - install required packages for Factor on Linux using dnf"
766     $ECHO "  deps-pkg - install required packages for Factor on FreeBSD using pkg"
767     $ECHO "  deps-macosx - install git on MacOSX using port"
768     $ECHO "  self-update - git pull, recompile, make local boot image, bootstrap"
769     $ECHO "  quick-update - git pull, refresh-all, save"
770     $ECHO "  update|latest - git pull, recompile, download a boot image, bootstrap"
771     $ECHO "  compile - compile the binary"
772     $ECHO "  recompile - recompile the binary"
773     $ECHO "  bootstrap - bootstrap with existing boot image"
774     $ECHO "  net-bootstrap - recompile, download a boot image, bootstrap"
775     $ECHO "  make-target - find and print the os-arch-cpu string"
776     $ECHO "  report|info - print the build variables"
777     $ECHO "  update-boot-image - get the boot image for the current branch"
778     $ECHO ""
779     $ECHO "If you are behind a firewall, invoke as:"
780     $ECHO "env GIT_PROTOCOL=http $0 <command>"
781     $ECHO ""
782     $ECHO "Example for overriding the default target:"
783     $ECHO "    $0 update macosx-x86-32"
784 }
785
786 MAKE_TARGET=unknown
787
788 # -n is nonzero length, -z is zero length
789 if [[ -n "$2" ]] ; then
790     parse_build_info $2
791 fi
792
793 if [ "$#" -gt 3 ]; then
794     usage
795     $ECHO "error: too many arguments"
796     exit 1
797 fi
798
799
800 set_copy
801 set_delete
802
803 case "$1" in
804     install) install ;;
805     deps-apt) install_deps_apt ;;
806     deps-pacman) install_deps_pacman ;;
807     deps-macosx) install_deps_macosx ;;
808     deps-dnf) install_deps_dnf ;;
809     deps-pkg) install_deps_pkg ;;
810     self-bootstrap) get_config_info; make_boot_image; bootstrap;;
811     self-update) update; make_boot_image; bootstrap;;
812     quick-update) update; refresh_image ;;
813     update|latest) update; download_and_bootstrap ;;
814     compile) find_build_info; make_factor ;;
815     recompile) find_build_info; make_clean; make_factor ;;
816     bootstrap) get_config_info; bootstrap ;;
817     net-bootstrap) net_bootstrap_no_pull ;;
818     make-target) FIND_MAKE_TARGET=true; ECHO=false; find_build_info; exit_script ;;
819     report|info) find_build_info ;;
820     full-report) find_build_info; check_installed_programs; check_libraries ;;
821     update-boot-image) find_build_info; check_installed_programs; update_boot_image;;
822     *) usage ;;
823 esac
824